import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class EigenUsedQR extends Frame
{  public int Iter;
   public EigenUsedQR()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public double [][] MultM(double [][] A,double [][] B, int N1,int N2,int N3)
   {  int i,j,k;
      double [][] C = new double[N1][N3];
      for(i = 0; i < N1; i++)for(j = 0; j < N3;j++)
      {  C[i][j]=0.0; for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public void QR_D(double [][] A,double [][] Q,double [][] R,int N)
   { int i, j, k; double Rjk, T;
     double [] X = new double[N];
     for(k = 0; k < N; k++)
     { for(i = 0; i < N; i++) X[i] =A[i][k];
       for(j = 0; j <= k-1; j++)
       {  Rjk = 0;
          for(i = 0; i < N; i++) Rjk += A[i][k] * Q[i][j];
          R[j][k] = Rjk; R[k][j] = 0;
          for(i = 0; i < N; i++) X[i] -= Rjk * Q[i][j];
       }  
       T = 0;for(i=0;i<N;i++) T += X[i] * X[i];
       R[k][k] = Math.sqrt(T);
       for(j = 0; j < N; j++) Q[j][k] = X[j] / R[k][k];
     }
   }
   public double[][] EigenValue(double [][] A, double EPS, int iterMax, int N)
   {  int i, j;
      double [][] Q = new double[N][N];
      double [][] R = new double[N][N];
      double [][] AA = A;
      Iter = 0;  double E = EPS * 100; double E2 = EPS * EPS;
      while( Iter < iterMax && E > E2)
      { Iter++;
        QR_D(AA, Q, R, N);
        AA = MultM(R, Q, N, N, N);
        E = 0; for(i = 1; i < N; i++) for(j = 0; j <= i - 1; j++) E += AA[i][j] * AA[i][j];
      }
      return AA;
   }
   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  double DN = 10 * Math.pow(10.0,(double)(N-1));
      double DX =  D * DN; if(Math.abs(DX)<0.5)return 0;
      return Math.rint(DX)/DN;
   }
   public void DrawData(Graphics g, int Y, double [][] A,int N)
   {  int i, j;
      for(i=0;i<N;i++)
      {
         for(j=0;j<N; j++)
         {  g.drawString( "" + round(A[i][j],3), 50 + j * 50,Y + i * 20);
         }
      }
      drawBra(g, 40, Y - 10, 70); drawKet(g,240, Y - 10, 70);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A  = {{4,2,1,3},{2,3,1,2},{1,1,2,1},{3,2,1,1}};
      setTitle("QRɂ镡ŗLl");
      g.drawString( "f[^",20,50);
      DrawData(g, 80, A, 4);
      double [][]AA = EigenValue(A, 0.00001, 100, 4);
      g.drawString( "mF (JԂ : " + Iter + ") ΊpvfŗLl" , 20, 170);
      DrawData(g, 200, AA, 4);
   } 
   public static void main(String[] args)
   {  Frame w = new EigenUsedQR();
      w.setVisible(true);
   }
}
